<!-- omit in toc -->

<!-- # ![graphql-codegen — Secure codegens for your targets.](https://github.com/domjtalbot/nx-graphql-codegen/raw/main/.github/banner-3.png 'graphql-codegen — Secure codegens for your targets.') -->

<br/>

<div align="center">
  <p dir="auto">
    <a href="https://github.com/sponsors/domjtalbot">
      <img src="https://img.shields.io/badge/Sponsor @domjtalbot-30363D?style=flat&logo=GitHub-Sponsors&logoColor=#EA4AAA" alt="Sponsor @domjtalbot on GitHub!" />
    </a>
    <a href="https://www.npmjs.org/package/nx-graphql-codegen">
      <img src="https://img.shields.io/npm/v/nx-graphql-codegen?style=flat" alt="nx-graphql-codegen package on NPM" />
    </a>
    <a href="https://www.npmjs.org/package/nx-graphql-codegen">
      <img src="https://img.shields.io/npm/dm/nx-graphql-codegen" alt="nx-graphql-codegen package downloads on NPM" aria-hidden="true" />
    </a>
    <a href="https://sonarcloud.io/summary/new_code?id=domjtalbot_nx-graphql-codegen">
      <img src="https://sonarcloud.io/api/project_badges/measure?project=domjtalbot_nx-graphql-codegen&metric=alert_status" alt="SonarCloud Quality Gate Status" aria-hidden="true" />
    </a>
  </p>
</div>

<br/>

## Contents

- [Features](#features)
- [Installing](#installing)
  - [Peer Dependencies](#peer-dependencies)
- [Executors](#executors)
  - [`codegen`](#codegen)
- [Generators](#generators)
  - [`codegen`](#codegen-1)
- [Examples](#examples)
- [Compatibility](#compatibility)
- [Credits](#credits)

<br/>

## Features

- Use [`graphql-codegen`](https://the-guild.dev/graphql/codegen) to generate code from GraphQL Schemas.

<br/>

## Installing

Using [pnpm](http://pnpm.io):

```bash
pnpm add -D nx-graphql-codegen
```

<details>
  <summary>Using npm</summary>

```bash
npm install -D nx-graphql-codegen
```

</details>

<details>
  <summary>Using yarn</summary>

```bash
yarn add -D nx-graphql-codegen
```

</details>

<br/>

### Peer Dependencies

| Name                  | Version    | Required |
| --------------------- | ---------- | :------: |
| `nx`                  | `>=15.7.1` |    ✅    |
| `@graphql-codgen/cli` | `>=2.16.1` |    ✅    |

<br/>

## Executors

### `codegen`

Run graphql-codegen.

```json
"targets": {
  "codegen": {
    "executor": "nx-graphql-codegen:codegen",
    "options": {
      "config": "libs/my-lib/codegen.ts",
    },
  },
}
```

<details>
  <summary>codegen executor options</summary>

| Name        | Type       | Required | Default | Description                                                                                   |
| ----------- | ---------- | :------: | ------- | --------------------------------------------------------------------------------------------- |
| `config`    | `string`   |    ✅    | -       | Path to GraphQL codegen YAML config file, defaults to `codegen.yml` on the current directory. |
| `debug`     | `boolean`  |    -     | `false` | Display debugging info by applying the `DEBUG` env variable.                                  |
| `overwrite` | `boolean`  |    -     | `true`  | Overwrites existing files.                                                                    |
| `profile`   | `boolean`  |    -     | `false` | Use profiler to measure performance.                                                          |
| `project`   | `string`   |    -     | ``      | Name of a project in GraphQL Config.                                                          |
| `require`   | `string[]` |    -     | `[]`    | Loads specific require.extensions before running the codegen and reading the configuration.   |
| `silent`    | `boolean`  |    -     | `false` | Suppresses printing errors.                                                                   |
| `watch`     | `boolean`  |    -     | `false` | Watch for changes and execute generation automatically.                                       |

</details>

<br/>

## Generators

### `codegen`

Generate a target to run a graphql-codegen.

```bash
nx generate nx-graphql-codegen:codegen dev --project=my-app --config='packages/my-lib/codegen.ts'
```

<details>
  <summary>codegen generator output</summary>

```bash
>  NX  Generating nx-graphql-codegen:codegen

UPDATE libs/my-lib/project.json
```

</details>

<details>
  <summary>codegen generator options</summary>

| Name      | Alias | Type     | Required | Default | Description                                                                                   |
| --------- | ----- | -------- | :------: | ------- | --------------------------------------------------------------------------------------------- |
| `config`  | -     | `string` |    ✅    | -       | Path to GraphQL codegen YAML config file, defaults to `codegen.yml` on the current directory. |
| `name`    | -     | `string` |    ✅    | -       | Target name.                                                                                  |
| `project` | -     | `string` |    ✅    | -       | What project does the target belong to?                                                       |

</details>

<br/>

## Examples

| Name                                                                                                               | Path                             |
| ------------------------------------------------------------------------------------------------------------------ | -------------------------------- |
| [typescript-operations](https://github.com/domjtalbot/nx-graphql-codegen/tree/main/examples/typescript-operations) | `examples/typescript-operations` |

<br/>

## Compatibility

| `nx-graphql-codegen` | Nx        |
| -------------------- | --------- |
| `^0.0.0`             | `^15.7.1` |

<br/>

## Credits

This plugin wouldn't be possible without the great teams behind these projects:

- [The Guild](https://www.the-guild.dev) - The team behind [GraphQL Codegen](https://github.com/dotansimha/graphql-code-generator).
- [Nrwl](https://github.com/nrwl) - The team behind [Nx](https://github.com/nrwl/nx)

Please show them your support! ❤️

<br/>
<br/>

<p align="center">🌳 🦌 🌳</p>

<br/>
