"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.codegenSchematic = exports.codegenGenerator = void 0;
const tslib_1 = require("tslib");
const devkit_1 = require("@nrwl/devkit");
function codegenGenerator(tree, config) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        const project = (0, devkit_1.readProjectConfiguration)(tree, config.project);
        project.targets = project.targets || {};
        const options = {
            config: config.config,
        };
        Object.keys(options).forEach((key) => options[key] === undefined && delete options[key]);
        project.targets[config.name] = {
            executor: 'nx-graphql-codegen:codegen',
            options,
        };
        (0, devkit_1.updateProjectConfiguration)(tree, config.project, project);
        yield (0, devkit_1.formatFiles)(tree);
    });
}
exports.codegenGenerator = codegenGenerator;
exports.default = codegenGenerator;
exports.codegenSchematic = (0, devkit_1.convertNxGenerator)(codegenGenerator);
//# sourceMappingURL=codegen.js.map