"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generator = void 0;
const tslib_1 = require("tslib");
const devkit_1 = require("@nrwl/devkit");
const js_1 = require("@nrwl/js");
const add_dependencies_1 = require("./lib/add-dependencies");
const add_project_config_1 = require("./lib/add-project-config");
const create_files_1 = require("./lib/create-files");
const normalize_options_1 = require("./lib/normalize-options");
function generator(tree, options) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        const normalizedOptions = (0, normalize_options_1.normalizeOptions)(tree, options);
        yield (0, js_1.libraryGenerator)(tree, normalizedOptions.libraryGeneratorOptions);
        (0, create_files_1.createFiles)(tree, normalizedOptions);
        (0, add_project_config_1.addProjectConfig)(tree, normalizedOptions);
        (0, add_dependencies_1.addDependencies)(tree, normalizedOptions);
        yield (0, devkit_1.formatFiles)(tree);
    });
}
exports.generator = generator;
exports.default = generator;
//# sourceMappingURL=generator.js.map