"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addDependencies = void 0;
const devkit_1 = require("@nrwl/devkit");
function addDependencies(tree, options) {
    let exampleDeps = {
        '@graphql-codegen/cli': '^3.3.1',
        '@graphql-typed-document-node/core': '^3.1.2',
        graphql: '^16.6.0',
    };
    switch (options.type) {
        case 'angular':
            exampleDeps = Object.assign(Object.assign({}, exampleDeps), { '@graphql-codegen/typescript-apollo-angular': '^3.5.6' });
            break;
        case 'backend':
            exampleDeps = Object.assign(Object.assign({}, exampleDeps), { '@graphql-codegen/typescript': '^3.0.4', '@graphql-codegen/typescript-resolvers': '^3.2.1' });
            break;
        case 'client':
        case 'graphql-request':
        case 'react':
        case 'vue':
            exampleDeps = Object.assign(Object.assign({}, exampleDeps), { '@graphql-codegen/client-preset': '^3.0.1' });
            break;
        case 'stencil':
            exampleDeps = Object.assign(Object.assign({}, exampleDeps), { '@graphql-codegen/typescript': '^3.0.4', '@graphql-codegen/typescript-operations': '^3.0.4', '@graphql-codegen/typescript-stencil-apollo': '^2.3.6' });
            break;
        case 'typescript':
            exampleDeps = Object.assign(Object.assign({}, exampleDeps), { '@graphql-codegen/typescript': '^3.0.4' });
            break;
    }
    return (0, devkit_1.addDependenciesToPackageJson)(tree, exampleDeps, {});
}
exports.addDependencies = addDependencies;
exports.default = addDependencies;
//# sourceMappingURL=add-dependencies.js.map