import type { libraryGeneratorSchema as NxLibraryGeneratorSchema } from '@nrwl/js';

export type CodegenSchema = {
  configName: string;
  documents: string;
  introspection: boolean;
  schema: string;
  type:
    | 'angular'
    | 'backend'
    | 'client'
    | 'graphql-request'
    | 'react'
    | 'stencil'
    | 'typescript'
    | 'vue';
};

export type LibraryGeneratorSchema = NxLibraryGeneratorSchema & CodegenSchema;

export interface NormalizedSchema extends CodegenSchema {
  configPath: string;
  libraryGeneratorOptions: NxLibraryGeneratorSchema;
  parsedTags: string[];
  projectDirectory: string;
  projectName: string;
  projectRoot: string;
}
