export declare type Maybe<T> = T | null;
export declare type InputMaybe<T> = Maybe<T>;
export declare type Exact<T extends {
    [key: string]: unknown;
}> = {
    [K in keyof T]: T[K];
};
export declare type MakeOptional<T, K extends keyof T> = Omit<T, K> & {
    [SubKey in K]?: Maybe<T[SubKey]>;
};
export declare type MakeMaybe<T, K extends keyof T> = Omit<T, K> & {
    [SubKey in K]: Maybe<T[SubKey]>;
};
/** All built-in and custom scalars, mapped to their actual values */
export declare type Scalars = {
    ID: string;
    String: string;
    Boolean: boolean;
    Int: number;
    Float: number;
    Date: any;
};
export declare type Chat = Node & {
    __typename?: 'Chat';
    id: Scalars['ID'];
    messages: Array<ChatMessage>;
    users: Array<User>;
};
export declare type ChatMessage = Node & {
    __typename?: 'ChatMessage';
    content: Scalars['String'];
    id: Scalars['ID'];
    time: Scalars['Date'];
    user: User;
};
export declare type Node = {
    id: Scalars['ID'];
};
export declare type Query = {
    __typename?: 'Query';
    allUsers?: Maybe<Array<Maybe<User>>>;
    me: User;
    myChats: Array<Chat>;
    search: Array<SearchResult>;
    user?: Maybe<User>;
};
export declare type QuerySearchArgs = {
    term: Scalars['String'];
};
export declare type QueryUserArgs = {
    id: Scalars['ID'];
};
export declare enum Role {
    Admin = "ADMIN",
    User = "USER"
}
export declare type SearchResult = Chat | ChatMessage | User;
export declare type User = Node & {
    __typename?: 'User';
    email: Scalars['String'];
    id: Scalars['ID'];
    role: Role;
    username: Scalars['String'];
};
export declare type FindUserQueryVariables = Exact<{
    userId: Scalars['ID'];
}>;
export declare type FindUserQuery = {
    __typename?: 'Query';
    user?: {
        __typename?: 'User';
        id: string;
        username: string;
        role: Role;
    } | null;
};
export declare type UserFieldsFragment = {
    __typename?: 'User';
    id: string;
    username: string;
    role: Role;
};
